# -*- coding: utf-8 -*-
"""
Created on Fri Oct 16 14:35:07 2020

@author: gabip
"""
from tkinter import *
from formes import *
from tkinter.colorchooser import askcolor

class ZoneAffichage(Canvas):
    def __init__(self, parent, largeur, hauteur):
        Canvas.__init__(self, parent, width=largeur, height=hauteur)
        self.forme_actuelle = 'Rectangle'
        self.__ListeFormes=[]
        self.__forme_deplacee = None
    
    def ajout_forme(self,x,y):
        if self.forme_actuelle == 'Rectangle':
            f= Rectangle(self,x, y ,20 ,10,'brown')
            self.__ListeFormes.append(f)
        else:
            f= Ellipse(self,x,y,25,25,'brown')
            self.__ListeFormes.append(f)
    def selection_rectangle(self):
        self.forme_actuelle='Rectangle'
    def selection_ellipse(self):
        self.forme_actuelle='Ellipse'
    
    def effacer(self,x,y):
        for i in self.__ListeFormes:
            if i.contient_point(x,y)==True:
                i.effacer()
                self.__ListeFormes.remove(i)
                break
    def color(self):
        couleur=askcolor()[1]
        for f in self.__ListeFormes:
            f.change_couleur(couleur)
        
class FenPrincipale(Tk):
    def __init__(self):
        Tk.__init__(self)
        # L'initialisation de l'arbre de scène se fait ici
        self.configure(bg='grey')
        
        BarreOutils = Frame(self)
        BarreOutils.pack(side=TOP)
        
        boutonRectangle = Button(BarreOutils, text='Rectangle')
        boutonRectangle.pack(side=LEFT, padx=5, pady=5)
        boutonEllipse = Button(BarreOutils, text='Ellipse')
        boutonEllipse.pack(side=LEFT, padx=5,pady=5)
        boutonCouleur = Button(BarreOutils, text='Couleur')
        boutonCouleur.pack(side=LEFT, padx=5,pady=5)
        boutonQuitter = Button(BarreOutils, text='Quitter')
        boutonQuitter.pack(side=LEFT, padx=5,pady=5)
        
        
        self.__canevas = ZoneAffichage(self,600,400)
        self.__canevas.pack(side=TOP, padx=10, pady=10)
        self.__canevas.bind('<ButtonRelease-1>',self.release_canevas)
        boutonRectangle.config(command=self.__canevas.selection_rectangle)
        boutonEllipse.config(command=self.__canevas.selection_ellipse)
        self.__canevas.bind('<Control-Button-1>',self.ctrlclick)
        boutonCouleur.config(command=self.__canevas.color)
        self.__canevas.bind('<Button-1>',self.clic_canevas)
        
    def release_canevas(self,event):
        self.__canevas.ajout_forme(event.x,event.y)
    
    
    
    def ctrlclick(self,event):
        self.__canevas.effacer(event.x,event.y)
        
    def clic_canevas(self,event):
        pass
    
    
if __name__ == "__main__":
    fen = FenPrincipale()
    fen.mainloop()        
    

